//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ic_main.h"

#include <IniFiles.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "CPortCtl"
#pragma resource "*.dfm"
TForm1 *Form1;

const char * speeds[]={"slow","medium","fast"};
const char * durs[]={"long","medium","short"};
const char * bools[]={"no","yes"};

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::eventsIdle(TObject *Sender, bool &Done)
{
	cbConnected->Checked = cport->Connected;
	btn_send->Enabled=cport->Connected;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cbConnectedClick(TObject *Sender)
{
	cport->Connected = !cport->Connected;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Exit1Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::on_create(TObject *Sender)
{
	int n;

	FList=new TList();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::on_destroy(TObject *Sender)
{
	FreeAndNil(&FList);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Add1Click(TObject *Sender)
{
	NewTextItem();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::NewTextItem()
{
	TTextItem * i;
	int n;

	i=new TTextItem();
	n=AddTextItem(i);
	BeginEditTextItem(n);
}
//---------------------------------------------------------------------------
int __fastcall TForm1::AddTextItem(TTextItem * item)
{
	int r;
	r=List->Add(item);
	lb_list->Count=List->Count;
	return r;
}
//---------------------------------------------------------------------------
TTextItem * __fastcall TForm1::DelTextItem(int index)
{
	TTextItem * r;

	r=(TTextItem *)List->Items[index];
	List->Delete(index);
	lb_list->Count=List->Count;
	return r;
}
//---------------------------------------------------------------------------
TTextItem * __fastcall TForm1::RemTextItem(TTextItem * item)
{
	TTextItem * r;

	r=(TTextItem *)List->Extract((void *)item);
	lb_list->Count=List->Count;
	return r;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::on_draw_item(TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State)
{
	TColor bk;
	TRect mirc,erc;
	TCanvas * c=lb_list->Canvas;
	TTextItem * ti=TextItems[Index];
	unsigned long rop;
	AnsiString s;

	bk=(State.Contains(odSelected) ? clHighlight : lb_list->Color);

	if (inplace_edit->Visible)
		PlaceInplaceEditor(FEditIndex);

	c->Brush->Color=bk;
	c->FillRect(Rect);
	DrawEdge(c->Handle,&Rect,EDGE_RAISED,BF_RECT);

	mirc.left=mirc.top=3;
	mirc.bottom=mirc.right=lb_list->ItemHeight-3;
	OffsetRect(mirc,Rect.left,Rect.top);
	DrawEdge(c->Handle,&mirc,EDGE_SUNKEN,BF_RECT|BF_ADJUST);

	rop=ti->Inverse ? NOTSRCCOPY : SRCCOPY;

	StretchBlt(c->Handle,
		mirc.left,mirc.top,mirc.Width(),mirc.Height(),
		modeimages->Picture->Bitmap->Canvas->Handle,
		ti->Mode*50,0,50,50,rop);

	if (ti->Mode>0){
		s.sprintf("spd:%s",speeds[ti->Speed]);
		c->TextOutA(Rect.left+55,Rect.top+4,s);
	}

	if (ti->Mode==3 || ti->Mode==4 || ti->Mode==2){
		s.sprintf("dur:%s",durs[ti->Duration]);
		c->TextOutA(Rect.left+55,Rect.top+20,s);
	}

	if (ti->Mode==2){
		s.sprintf("blink:%s",bools[(int)ti->Blink]);
		c->TextOutA(Rect.left+55,Rect.top+36,s);
	}

	erc=InplaceEditorRect(Index);
	DrawEdge(c->Handle,&erc,EDGE_ETCHED,BF_RECT|BF_ADJUST);
	DrawText(c->Handle,TextItems[Index]->Text.c_str(),-1,&erc,DT_EDITCONTROL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::on_resize(TObject *Sender)
{
	lb_list->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::m1DrawItem(TObject *Sender, TCanvas *ACanvas,TRect &ARect, bool Selected)
{
	TRect mirc=ARect;
	TMenuItem * mi=(TMenuItem *)Sender;
	int in=mi->Parent->IndexOf(mi);
	bool inv=false;
	in=in>6 ? (inv=true,in-7) : in;

	unsigned long mode = inv ? NOTSRCCOPY : SRCCOPY;
	unsigned int edge = Selected ? EDGE_BUMP : EDGE_ETCHED;

	StretchBlt(ACanvas->Handle,
		mirc.left,mirc.top,mirc.Width(),mirc.Height(),
		modeimages->Picture->Bitmap->Canvas->Handle,
		in*50,0,50,50,mode);
	DrawEdge(ACanvas->Handle,&mirc,edge,BF_RECT);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::m1MeasureItem(TObject *Sender, TCanvas *ACanvas, int &Width, int &Height)
{
	Width=Height=35;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::lb_listMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (Button==mbLeft) {
		TRect rc, mirc;
		TPoint pt;
		TTextItem * ti;
		TCanvas * c=lb_list->Canvas;
		AnsiString s;

		pt.x=X; pt.y=Y;
		int ii=lb_list->ItemAtPos(pt,true);
		FPopOverItem=ii;
		if (ii==-1)
			return;
		ti=TextItems[ii];
		rc=lb_list->ItemRect(ii);

		mirc.left=mirc.top=3;
		mirc.bottom=mirc.right=lb_list->ItemHeight-3;
		OffsetRect(mirc,rc.left,rc.top);

		if (PtInRect(mirc,pt)) {
			pt.x=rc.left+3; pt.y=rc.top+3;
			pt=lb_list->ClientToScreen(pt);

			pm_modesel->Popup(pt.x,pt.y);
			return;
		}

		if (ti->Mode>0){
			s.sprintf("spd:%s",speeds[ti->Speed]);
			if (TextHit(c,rc.left+55,rc.top+4,pt,s)){
				ti->Speed+=1;
				if (ti->Mode>1 && ti->Mode<5 && ti->Speed==1)
					ti->Speed+=1;
				if (ti->Speed>2)
					ti->Speed=0;
				InvalItem(ii);
				return;
			}
		}

		if (ti->Mode==3 || ti->Mode==4 || ti->Mode==2){
			s.sprintf("dur:%s",durs[ti->Duration]);
			if (TextHit(c,rc.left+55,rc.top+20,pt,s)){
				ti->Duration+=1;
				if (ti->Duration>2)
					ti->Duration=0;
				InvalItem(ii);
				return;
			}
		}

		if (ti->Mode==2){
			s.sprintf("blink:%s",bools[(int)ti->Blink]);
			if (TextHit(c,rc.left+55,rc.top+36,pt,s)){
				ti->Blink=!ti->Blink;
				InvalItem(ii);
				return;
			}
		}

	}
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::TextHit(TCanvas * cnv, int xTx, int yTx, TPoint pt, AnsiString tx)
{
	TSize sz=cnv->TextExtent(tx);
	TRect rctx(0,0,sz.cx,sz.cy);
	OffsetRect(rctx,xTx,yTx);
	return PtInRect(rctx,pt);
}
//---------------------------------------------------------------------------
TTextItem * __fastcall TForm1::GetTextItems(int index)
{
	return (TTextItem *)List->Items[index];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::mode_selected(TObject *Sender)
{
	TMenuItem * mi=(TMenuItem *)Sender;
	int mm=mi->Parent->IndexOf(mi);
	bool inv=false;

	mm = mm>6 ? (inv=true,mm-7) : mm;

	TextItems[FPopOverItem]->Mode=mm;
	TextItems[FPopOverItem]->Inverse=inv;
	InvalItem(FPopOverItem);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::InvalItem(int index)
{
	TRect rci=lb_list->ItemRect(index);
	InvalidateRect(lb_list->Handle,&rci,true);
}
//---------------------------------------------------------------------------
TRect __fastcall TForm1::InplaceEditorRect(int index)
{
	union _u {
		RECT rc;
		struct {
		POINT tl,br;
		}pts;
	} u;
	u.rc=lb_list->ItemRect(index);

	InflateRect(&u.rc,-2,-2);
	u.rc.left=130;
	return TRect(u.rc);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PlaceInplaceEditor(int index)
{

	inplace_edit->Parent=lb_list;
	inplace_edit->PopupMenu=NULL;
	inplace_edit->BoundsRect=TRect(InplaceEditorRect(index));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BeginEditTextItem(int index)
{
	TMemo * ie=inplace_edit;

	PlaceInplaceEditor(index);
	FEditIndex=index;
	ie->Text=TextItems[index]->Text;
	ie->Visible=true;
	ie->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EndEditTextItem()
{
	inplace_edit->Visible=false;
	TextItems[FEditIndex]->Text=inplace_edit->Text;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::inplace_editExit(TObject *Sender)
{
	EndEditTextItem();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::lb_listDblClick(TObject *Sender)
{
	TPoint pt=Mouse->CursorPos;
	pt=lb_list->ScreenToClient(pt);
	int n=lb_list->ItemAtPos(pt,true);
	if (n!=-1 && pt.x>130)
		BeginEditTextItem(n);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::inplace_editKeyUp(TObject *Sender, WORD &Key,TShiftState Shift)
{
	if (Key==(WORD)VK_RETURN)
		EndEditTextItem();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btn_sendClick(TObject *Sender)
{
	char ctl[] ={0x0d,0x0d,0x0d,0x0a,0x01};
	int n;
	char fin=0x1a;

	progress->Visible=true;
	progress->Min=0;
	progress->Max=List->Count-1;
	cport->Write(&ctl,5);

	for (n=0; n<List->Count; n++){
		char array[] = {0x01,0x02,0x02,0x03,0x03,0x03};
		progress->Position=n;
		array[0]=1+(char)TextItems[n]->Mode;
		array[1]=1+(int)TextItems[n]->Inverse;
		array[2]=2; // latinica
		array[3]=1+(int)TextItems[n]->Blink;
		array[4]=1+TextItems[n]->Duration;
		array[5]=1+TextItems[n]->Speed;
		cport->Write(&array,6);

		AnsiString tx=TextItems[n]->Text;
		if (TextItems[n]->Mode>2) {
			if (tx.Length()>16){
				tx.SetLength(16);
			}
			if (TextItems[n]->Inverse && tx.Length()<16){
				while (tx.Length()<16)
					tx+=' ';
			}
		}

		cport->WriteStr(tx);
		cport->Write(&ctl,1);
	};
	cport->Write(&fin,1);
	progress->Visible=false;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

void __fastcall TForm1::Save1Click(TObject *Sender)
{
	if (FFileName.Length()==0)
		SaveAs1Click(Sender);
	else
		SaveDocument(FFileName);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveAs1Click(TObject *Sender)
{
	if (dlgSave->Execute())
		SaveDocument(ChangeFileExt(dlgSave->FileName,".ipl"));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveDocument(AnsiString fname)
{
	AnsiString sect;

	FFileName=fname;
	TIniFile * ifi=new TIniFile(FFileName);

	ifi->WriteString("info","sig","INFOS control playlist");
	ifi->WriteInteger("info","icount",List->Count);

	for (int n=0; n<List->Count; n++) {
		sect.sprintf("TxItem(0x%lx)",n);
		ifi->WriteString(sect,"Text",TextItems[n]->Text);
		ifi->WriteInteger(sect,"Mode",TextItems[n]->Mode);
		ifi->WriteInteger(sect,"Speed",TextItems[n]->Speed);
		ifi->WriteInteger(sect,"Duration",TextItems[n]->Duration);
		ifi->WriteBool(sect,"Blink",TextItems[n]->Blink);
	}

	delete ifi;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LoadDocument(AnsiString fname)
{
	AnsiString sect;
	TIniFile * ifi;
	int n,tc;
	TTextItem * nti;

	if (! FileExists(fname)) {
		MessageBeep(MB_ICONERROR);
		return;
	}

	New1Click(this);
	FFileName=fname;

	ifi = new TIniFile(FFileName);

	tc=ifi->ReadInteger("info","icount",0);

	for (n=0; n<tc; n++){
		sect.sprintf("TxItem(0x%lx)",n);

		nti=new TTextItem();
		nti->Text=ifi->ReadString(sect,"Text","");
		nti->Mode=ifi->ReadInteger(sect,"Mode",0);
		nti->Speed=ifi->ReadInteger(sect,"Speed",1);
		nti->Duration=ifi->ReadInteger(sect,"Duration",1);
		nti->Blink=ifi->ReadBool(sect,"Blink",false);
		AddTextItem(nti);
	}

	delete ifi;
	lb_list->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::New1Click(TObject *Sender)
{
	while (List->Count>0)
		delete List->Extract(List->First());
	FFileName="";
	lb_list->Count=0;
	lb_list->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Open1Click(TObject *Sender)
{
	if (dlgOpen->Execute())
		LoadDocument(dlgOpen->FileName);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MoveUp1Click(TObject *Sender)
{
	int ii=lb_list->ItemIndex;
	if (ii>0)
		List->Move(ii,ii-1);
	lb_list->ItemIndex=ii-1;
	lb_list->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MoveDown1Click(TObject *Sender)
{
	int ii=lb_list->ItemIndex;
	if (ii==-1)
		return;
	if (ii<lb_list->Count-1)
		List->Move(ii,ii+1);
	lb_list->ItemIndex=ii+1;
	lb_list->Invalidate();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Deleteitem1Click(TObject *Sender)
{
	if (lb_list->ItemIndex!=-1) {
		delete List->Extract(TextItems[lb_list->ItemIndex]);
		lb_list->Count=List->Count;
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::lb_listKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (Key==VK_DELETE)
		Deleteitem1Click(this);
}
//---------------------------------------------------------------------------



